<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AbstractConnPool xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/apache/http/impl/conn/tsccm/AbstractConnPool.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> *  this work for additional information regarding copyright ownership.</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> *  the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> *  See the License for the specific language governing permissions and</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> *  limitations under the License.</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.conn.tsccm;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.lang.ref.Reference;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.lang.ref.ReferenceQueue;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.Set;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.util.HashSet;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.TimeUnit;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.locks.Lock;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.locks.ReentrantLock;
<a class="jxr_linenumber" name="38" href="#38">38</a>  
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.GuardedBy;
<a class="jxr_linenumber" name="40" href="#40">40</a>  
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.commons.logging.Log;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.commons.logging.LogFactory;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.ConnectionPoolTimeoutException;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.OperatedClientConnection;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.HttpRoute;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.conn.IdleConnectionHandler;
<a class="jxr_linenumber" name="47" href="#47">47</a>  
<a class="jxr_linenumber" name="48" href="#48">48</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="49" href="#49">49</a>  <em class="jxr_javadoccomment"> * An abstract connection pool.</em>
<a class="jxr_linenumber" name="50" href="#50">50</a>  <em class="jxr_javadoccomment"> * It is used by the {@link ThreadSafeClientConnManager}.</em>
<a class="jxr_linenumber" name="51" href="#51">51</a>  <em class="jxr_javadoccomment"> * The abstract pool includes a {@link #poolLock}, which is used to</em>
<a class="jxr_linenumber" name="52" href="#52">52</a>  <em class="jxr_javadoccomment"> * synchronize access to the internal pool datastructures.</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>  <em class="jxr_javadoccomment"> * Don't use &lt;code&gt;synchronized&lt;/code&gt; for that purpose!</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  <em class="jxr_javadoccomment"> * @deprecated (4.2) use {@link org.apache.http.pool.AbstractConnPool}</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  @Deprecated
<a class="jxr_linenumber" name="60" href="#60">60</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/conn/tsccm/AbstractConnPool.html">AbstractConnPool</a> {
<a class="jxr_linenumber" name="61" href="#61">61</a>  
<a class="jxr_linenumber" name="62" href="#62">62</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Log log;
<a class="jxr_linenumber" name="63" href="#63">63</a>  
<a class="jxr_linenumber" name="64" href="#64">64</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment">     * The global lock for this pool.</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>      <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> Lock poolLock;
<a class="jxr_linenumber" name="68" href="#68">68</a>  
<a class="jxr_linenumber" name="69" href="#69">69</a>      <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> References to issued connections */</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>      @GuardedBy(<span class="jxr_string">"poolLock"</span>)
<a class="jxr_linenumber" name="71" href="#71">71</a>      <strong class="jxr_keyword">protected</strong> Set&lt;BasicPoolEntry&gt; leasedConnections;
<a class="jxr_linenumber" name="72" href="#72">72</a>  
<a class="jxr_linenumber" name="73" href="#73">73</a>      <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> The current total number of connections. */</em>
<a class="jxr_linenumber" name="74" href="#74">74</a>      @GuardedBy(<span class="jxr_string">"poolLock"</span>)
<a class="jxr_linenumber" name="75" href="#75">75</a>      <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">int</strong> numConnections;
<a class="jxr_linenumber" name="76" href="#76">76</a>  
<a class="jxr_linenumber" name="77" href="#77">77</a>      <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Indicates whether this pool is shut down. */</em>
<a class="jxr_linenumber" name="78" href="#78">78</a>      <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">boolean</strong> isShutDown;
<a class="jxr_linenumber" name="79" href="#79">79</a>  
<a class="jxr_linenumber" name="80" href="#80">80</a>      <strong class="jxr_keyword">protected</strong> Set&lt;BasicPoolEntryRef&gt; issuedConnections;
<a class="jxr_linenumber" name="81" href="#81">81</a>  
<a class="jxr_linenumber" name="82" href="#82">82</a>      <strong class="jxr_keyword">protected</strong> ReferenceQueue&lt;Object&gt; refQueue;
<a class="jxr_linenumber" name="83" href="#83">83</a>  
<a class="jxr_linenumber" name="84" href="#84">84</a>      <strong class="jxr_keyword">protected</strong> <a href="../../../../../../org/apache/http/impl/conn/IdleConnectionHandler.html">IdleConnectionHandler</a> idleConnHandler;
<a class="jxr_linenumber" name="85" href="#85">85</a>  
<a class="jxr_linenumber" name="86" href="#86">86</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="87" href="#87">87</a>  <em class="jxr_javadoccomment">     * Creates a new connection pool.</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="89" href="#89">89</a>      <strong class="jxr_keyword">protected</strong> <a href="../../../../../../org/apache/http/impl/conn/tsccm/AbstractConnPool.html">AbstractConnPool</a>() {
<a class="jxr_linenumber" name="90" href="#90">90</a>          <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="91" href="#91">91</a>          <strong class="jxr_keyword">this</strong>.log = LogFactory.getLog(getClass());
<a class="jxr_linenumber" name="92" href="#92">92</a>          <strong class="jxr_keyword">this</strong>.leasedConnections = <strong class="jxr_keyword">new</strong> HashSet&lt;BasicPoolEntry&gt;();
<a class="jxr_linenumber" name="93" href="#93">93</a>          <strong class="jxr_keyword">this</strong>.idleConnHandler = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/conn/IdleConnectionHandler.html">IdleConnectionHandler</a>();
<a class="jxr_linenumber" name="94" href="#94">94</a>          <strong class="jxr_keyword">this</strong>.poolLock = <strong class="jxr_keyword">new</strong> ReentrantLock();
<a class="jxr_linenumber" name="95" href="#95">95</a>      }
<a class="jxr_linenumber" name="96" href="#96">96</a>  
<a class="jxr_linenumber" name="97" href="#97">97</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> enableConnectionGC()
<a class="jxr_linenumber" name="98" href="#98">98</a>          <strong class="jxr_keyword">throws</strong> IllegalStateException {
<a class="jxr_linenumber" name="99" href="#99">99</a>      }
<a class="jxr_linenumber" name="100" href="#100">100</a> 
<a class="jxr_linenumber" name="101" href="#101">101</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="102" href="#102">102</a> <em class="jxr_javadoccomment">     * Obtains a pool entry with a connection within the given timeout.</em>
<a class="jxr_linenumber" name="103" href="#103">103</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="104" href="#104">104</a> <em class="jxr_javadoccomment">     * @param route     the route for which to get the connection</em>
<a class="jxr_linenumber" name="105" href="#105">105</a> <em class="jxr_javadoccomment">     * @param timeout   the timeout, 0 or negative for no timeout</em>
<a class="jxr_linenumber" name="106" href="#106">106</a> <em class="jxr_javadoccomment">     * @param tunit     the unit for the &lt;code&gt;timeout&lt;/code&gt;,</em>
<a class="jxr_linenumber" name="107" href="#107">107</a> <em class="jxr_javadoccomment">     *                  may be &lt;code&gt;null&lt;/code&gt; only if there is no timeout</em>
<a class="jxr_linenumber" name="108" href="#108">108</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="109" href="#109">109</a> <em class="jxr_javadoccomment">     * @return  pool entry holding a connection for the route</em>
<a class="jxr_linenumber" name="110" href="#110">110</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="111" href="#111">111</a> <em class="jxr_javadoccomment">     * @throws ConnectionPoolTimeoutException</em>
<a class="jxr_linenumber" name="112" href="#112">112</a> <em class="jxr_javadoccomment">     *         if the timeout expired</em>
<a class="jxr_linenumber" name="113" href="#113">113</a> <em class="jxr_javadoccomment">     * @throws InterruptedException</em>
<a class="jxr_linenumber" name="114" href="#114">114</a> <em class="jxr_javadoccomment">     *         if the calling thread was interrupted</em>
<a class="jxr_linenumber" name="115" href="#115">115</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="116" href="#116">116</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong>
<a class="jxr_linenumber" name="117" href="#117">117</a>         <a href="../../../../../../org/apache/http/impl/conn/tsccm/BasicPoolEntry.html">BasicPoolEntry</a> getEntry(
<a class="jxr_linenumber" name="118" href="#118">118</a>                 <a href="../../../../../../org/apache/http/conn/routing/HttpRoute.html">HttpRoute</a> route,
<a class="jxr_linenumber" name="119" href="#119">119</a>                 Object state,
<a class="jxr_linenumber" name="120" href="#120">120</a>                 <strong class="jxr_keyword">long</strong> timeout,
<a class="jxr_linenumber" name="121" href="#121">121</a>                 TimeUnit tunit)
<a class="jxr_linenumber" name="122" href="#122">122</a>                     <strong class="jxr_keyword">throws</strong> ConnectionPoolTimeoutException, InterruptedException {
<a class="jxr_linenumber" name="123" href="#123">123</a>         <strong class="jxr_keyword">return</strong> requestPoolEntry(route, state).getPoolEntry(timeout, tunit);
<a class="jxr_linenumber" name="124" href="#124">124</a>     }
<a class="jxr_linenumber" name="125" href="#125">125</a> 
<a class="jxr_linenumber" name="126" href="#126">126</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="127" href="#127">127</a> <em class="jxr_javadoccomment">     * Returns a new {@link PoolEntryRequest}, from which a {@link BasicPoolEntry}</em>
<a class="jxr_linenumber" name="128" href="#128">128</a> <em class="jxr_javadoccomment">     * can be obtained, or the request can be aborted.</em>
<a class="jxr_linenumber" name="129" href="#129">129</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="130" href="#130">130</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <a href="../../../../../../org/apache/http/impl/conn/tsccm/PoolEntryRequest.html">PoolEntryRequest</a> requestPoolEntry(<a href="../../../../../../org/apache/http/conn/routing/HttpRoute.html">HttpRoute</a> route, Object state);
<a class="jxr_linenumber" name="131" href="#131">131</a> 
<a class="jxr_linenumber" name="132" href="#132">132</a> 
<a class="jxr_linenumber" name="133" href="#133">133</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="134" href="#134">134</a> <em class="jxr_javadoccomment">     * Returns an entry into the pool.</em>
<a class="jxr_linenumber" name="135" href="#135">135</a> <em class="jxr_javadoccomment">     * The connection of the entry is expected to be in a suitable state,</em>
<a class="jxr_linenumber" name="136" href="#136">136</a> <em class="jxr_javadoccomment">     * either open and re-usable, or closed. The pool will not make any</em>
<a class="jxr_linenumber" name="137" href="#137">137</a> <em class="jxr_javadoccomment">     * attempt to determine whether it can be re-used or not.</em>
<a class="jxr_linenumber" name="138" href="#138">138</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="139" href="#139">139</a> <em class="jxr_javadoccomment">     * @param entry     the entry for the connection to release</em>
<a class="jxr_linenumber" name="140" href="#140">140</a> <em class="jxr_javadoccomment">     * @param reusable  &lt;code&gt;true&lt;/code&gt; if the entry is deemed</em>
<a class="jxr_linenumber" name="141" href="#141">141</a> <em class="jxr_javadoccomment">     *                  reusable, &lt;code&gt;false&lt;/code&gt; otherwise.</em>
<a class="jxr_linenumber" name="142" href="#142">142</a> <em class="jxr_javadoccomment">     * @param validDuration The duration that the entry should remain free and reusable.</em>
<a class="jxr_linenumber" name="143" href="#143">143</a> <em class="jxr_javadoccomment">     * @param timeUnit The unit of time the duration is measured in.</em>
<a class="jxr_linenumber" name="144" href="#144">144</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="145" href="#145">145</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> freeEntry(<a href="../../../../../../org/apache/http/impl/conn/tsccm/BasicPoolEntry.html">BasicPoolEntry</a> entry, <strong class="jxr_keyword">boolean</strong> reusable, <strong class="jxr_keyword">long</strong> validDuration, TimeUnit timeUnit)
<a class="jxr_linenumber" name="146" href="#146">146</a>         ;
<a class="jxr_linenumber" name="147" href="#147">147</a> 
<a class="jxr_linenumber" name="148" href="#148">148</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handleReference(Reference&lt;?&gt; ref) {
<a class="jxr_linenumber" name="149" href="#149">149</a>     }
<a class="jxr_linenumber" name="150" href="#150">150</a> 
<a class="jxr_linenumber" name="151" href="#151">151</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> handleLostEntry(<a href="../../../../../../org/apache/http/conn/routing/HttpRoute.html">HttpRoute</a> route);
<a class="jxr_linenumber" name="152" href="#152">152</a> 
<a class="jxr_linenumber" name="153" href="#153">153</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="154" href="#154">154</a> <em class="jxr_javadoccomment">     * Closes idle connections.</em>
<a class="jxr_linenumber" name="155" href="#155">155</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="156" href="#156">156</a> <em class="jxr_javadoccomment">     * @param idletime  the time the connections should have been idle</em>
<a class="jxr_linenumber" name="157" href="#157">157</a> <em class="jxr_javadoccomment">     *                  in order to be closed now</em>
<a class="jxr_linenumber" name="158" href="#158">158</a> <em class="jxr_javadoccomment">     * @param tunit     the unit for the &lt;code&gt;idletime&lt;/code&gt;</em>
<a class="jxr_linenumber" name="159" href="#159">159</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="160" href="#160">160</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> closeIdleConnections(<strong class="jxr_keyword">long</strong> idletime, TimeUnit tunit) {
<a class="jxr_linenumber" name="161" href="#161">161</a> 
<a class="jxr_linenumber" name="162" href="#162">162</a>         <em class="jxr_comment">// idletime can be 0 or negative, no problem there</em>
<a class="jxr_linenumber" name="163" href="#163">163</a>         <strong class="jxr_keyword">if</strong> (tunit == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="164" href="#164">164</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Time unit must not be null."</span>);
<a class="jxr_linenumber" name="165" href="#165">165</a>         }
<a class="jxr_linenumber" name="166" href="#166">166</a> 
<a class="jxr_linenumber" name="167" href="#167">167</a>         poolLock.lock();
<a class="jxr_linenumber" name="168" href="#168">168</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="169" href="#169">169</a>             idleConnHandler.closeIdleConnections(tunit.toMillis(idletime));
<a class="jxr_linenumber" name="170" href="#170">170</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="171" href="#171">171</a>             poolLock.unlock();
<a class="jxr_linenumber" name="172" href="#172">172</a>         }
<a class="jxr_linenumber" name="173" href="#173">173</a>     }
<a class="jxr_linenumber" name="174" href="#174">174</a> 
<a class="jxr_linenumber" name="175" href="#175">175</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> closeExpiredConnections() {
<a class="jxr_linenumber" name="176" href="#176">176</a>         poolLock.lock();
<a class="jxr_linenumber" name="177" href="#177">177</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="178" href="#178">178</a>             idleConnHandler.closeExpiredConnections();
<a class="jxr_linenumber" name="179" href="#179">179</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="180" href="#180">180</a>             poolLock.unlock();
<a class="jxr_linenumber" name="181" href="#181">181</a>         }
<a class="jxr_linenumber" name="182" href="#182">182</a>     }
<a class="jxr_linenumber" name="183" href="#183">183</a> 
<a class="jxr_linenumber" name="184" href="#184">184</a> 
<a class="jxr_linenumber" name="185" href="#185">185</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="186" href="#186">186</a> <em class="jxr_javadoccomment">     * Deletes all entries for closed connections.</em>
<a class="jxr_linenumber" name="187" href="#187">187</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="188" href="#188">188</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> deleteClosedConnections();
<a class="jxr_linenumber" name="189" href="#189">189</a> 
<a class="jxr_linenumber" name="190" href="#190">190</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_javadoccomment">     * Shuts down this pool and all associated resources.</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_javadoccomment">     * Overriding methods MUST call the implementation here!</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="194" href="#194">194</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> shutdown() {
<a class="jxr_linenumber" name="195" href="#195">195</a> 
<a class="jxr_linenumber" name="196" href="#196">196</a>         poolLock.lock();
<a class="jxr_linenumber" name="197" href="#197">197</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="198" href="#198">198</a> 
<a class="jxr_linenumber" name="199" href="#199">199</a>             <strong class="jxr_keyword">if</strong> (isShutDown)
<a class="jxr_linenumber" name="200" href="#200">200</a>                 <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>             <em class="jxr_comment">// close all connections that are issued to an application</em>
<a class="jxr_linenumber" name="203" href="#203">203</a>             Iterator&lt;BasicPoolEntry&gt; iter = leasedConnections.iterator();
<a class="jxr_linenumber" name="204" href="#204">204</a>             <strong class="jxr_keyword">while</strong> (iter.hasNext()) {
<a class="jxr_linenumber" name="205" href="#205">205</a>                 <a href="../../../../../../org/apache/http/impl/conn/tsccm/BasicPoolEntry.html">BasicPoolEntry</a> entry = iter.next();
<a class="jxr_linenumber" name="206" href="#206">206</a>                 iter.remove();
<a class="jxr_linenumber" name="207" href="#207">207</a>                 closeConnection(entry.getConnection());
<a class="jxr_linenumber" name="208" href="#208">208</a>             }
<a class="jxr_linenumber" name="209" href="#209">209</a>             idleConnHandler.removeAll();
<a class="jxr_linenumber" name="210" href="#210">210</a> 
<a class="jxr_linenumber" name="211" href="#211">211</a>             isShutDown = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="212" href="#212">212</a> 
<a class="jxr_linenumber" name="213" href="#213">213</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="214" href="#214">214</a>             poolLock.unlock();
<a class="jxr_linenumber" name="215" href="#215">215</a>         }
<a class="jxr_linenumber" name="216" href="#216">216</a>     }
<a class="jxr_linenumber" name="217" href="#217">217</a> 
<a class="jxr_linenumber" name="218" href="#218">218</a> 
<a class="jxr_linenumber" name="219" href="#219">219</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="220" href="#220">220</a> <em class="jxr_javadoccomment">     * Closes a connection from this pool.</em>
<a class="jxr_linenumber" name="221" href="#221">221</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="222" href="#222">222</a> <em class="jxr_javadoccomment">     * @param conn      the connection to close, or &lt;code&gt;null&lt;/code&gt;</em>
<a class="jxr_linenumber" name="223" href="#223">223</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="224" href="#224">224</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> closeConnection(<strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/conn/OperatedClientConnection.html">OperatedClientConnection</a> conn) {
<a class="jxr_linenumber" name="225" href="#225">225</a>         <strong class="jxr_keyword">if</strong> (conn != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="226" href="#226">226</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="227" href="#227">227</a>                 conn.close();
<a class="jxr_linenumber" name="228" href="#228">228</a>             } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="229" href="#229">229</a>                 log.debug(<span class="jxr_string">"I/O error closing connection"</span>, ex);
<a class="jxr_linenumber" name="230" href="#230">230</a>             }
<a class="jxr_linenumber" name="231" href="#231">231</a>         }
<a class="jxr_linenumber" name="232" href="#232">232</a>     }
<a class="jxr_linenumber" name="233" href="#233">233</a> 
<a class="jxr_linenumber" name="234" href="#234">234</a> } <em class="jxr_comment">// class AbstractConnPool</em>
<a class="jxr_linenumber" name="235" href="#235">235</a> 
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

